diff -Nacr stunnel-3.8.orig/configure.in stunnel-3.8/configure.in
*** stunnel-3.8.orig/configure.in	Tue Feb 22 08:19:04 2000
--- stunnel-3.8/configure.in	Fri Jul 21 14:00:00 2000
***************
*** 42,47 ****
--- 42,56 ----
      return 1
  }
  
+ checkkrb5dir() { :
+ 	if test -f "$1/include/krb5.h"; then
+ 		AC_DEFINE(HAVE_KRB5)
+ 		krb5dir="$1"
+ 		return 0
+ 	fi
+     return 1
+ }
+ 
  dnl Check for SSL directory
  AC_MSG_CHECKING([for SSL directory])
  AC_ARG_WITH(ssl,
***************
*** 71,76 ****
--- 80,120 ----
  AC_SUBST(ssldir)
  AC_DEFINE_UNQUOTED(ssldir, "$ssldir")
  
+ dnl Check for KRB5 directory
+ AC_MSG_CHECKING([for KRB5 directory])
+ AC_ARG_WITH(krb5,
+     [  --with-krb5=DIR         location of installed KRB5 libraries/include files],
+     [
+ 		if test "$withval" != "yes"; then
+ 			dnl Check the specified localtion only
+ 			checkkrb5dir "$withval"
+ 		else
+ 			dnl Search default localtions of KRB5 library
+ 			for maindir in /usr/local /usr/lib /usr/pkg /opt; do
+ 				for dir in $maindir $maindir/krb5 ; do
+ 					checkkrb5dir $dir && break 2
+ 				done
+ 			done
+ 		fi
+     ],
+     [
+         dnl Otherwise, no KRB5 for you
+ 		AC_DEFINE(NO_KRB5)
+ 		echo
+     ]
+ )
+ if test "$krb5dir" != ""; then
+ 	AC_MSG_RESULT($krb5dir)
+     AC_SUBST(krb5dir)
+ fi
+ 
+ AC_MSG_CHECKING([whether you want to include the idea cipher])
+ AC_ARG_WITH(idea,
+ [  --without-idea          disable the idea cipher],
+ 	[use_idea=no ; CFLAGS="$CFLAGS -DNO_IDEA"],
+ 	[use_idea=yes])
+ AC_MSG_RESULT($use_idea)
+ 
  dnl Substitute host.
  AC_SUBST(host)
  AC_DEFINE_UNQUOTED(HOST, "$host")
***************
*** 94,99 ****
--- 138,150 ----
  dnl Add SSL includes and libraries
  CFLAGS="$CFLAGS -I$ssldir/include"
  LIBS="$LIBS -L$ssldir/lib -lssl -lcrypto"
+ 
+ if test "$krb5dir" != ""; then
+ dnl Add KRB5 includes and libraries
+ CFLAGS="$CFLAGS -I$krb5dir/include"
+ LIBS="$LIBS -L$krb5dir/lib -lgssapi_krb5 -lkrb5 -lcom_err"
+ LIBS="$LIBS $krb5dir/lib/libcrypto.a -lresolv"
+ fi
  
  dnl Check for RSAref library.
  AC_MSG_CHECKING([for RSAref library])
diff -Nacr stunnel-3.8.orig/ssl.c stunnel-3.8/ssl.c
*** stunnel-3.8.orig/ssl.c	Fri Feb 18 10:26:48 2000
--- stunnel-3.8/ssl.c	Fri Jul 21 14:01:03 2000
***************
*** 154,159 ****
--- 154,160 ----
      BIO *bio=NULL;
  #endif /* NO_DH */
  
+     yaapp_RAND_load_file(NULL, NULL, 0);
      SSLeay_add_ssl_algorithms();
      SSL_load_error_strings();
      if(options.option&OPT_CLIENT) {
***************
*** 321,326 ****
--- 322,339 ----
  #if SSLEAY_VERSION_NUMBER >= 0x0922
      SSL_set_session_id_context(ssl, sid_ctx, strlen(sid_ctx));
  #endif
+ #ifndef NO_KRB5
+ 	if (ssl->kssl_ctx)  {
+ 		kssl_ctx_setstring(ssl->kssl_ctx, KSSL_SERVICE, KRB5SVC);
+ 		kssl_ctx_setstring(ssl->kssl_ctx, KSSL_KEYTAB, KRB5KEYTAB);
+ 		}
+ 	if (ssl->kssl_ctx  &&  options.servname) {
+ 		char	*lastdot = strrchr(options.servname, '.');
+ 		if (lastdot)  *lastdot = '\0';
+ 		kssl_ctx_setstring(ssl->kssl_ctx, KSSL_SERVER, options.servname);
+ 		if (lastdot)  *lastdot = '.';
+ 		}
+ #endif	/* NO_KRB5 */
      if(options.option&OPT_CLIENT) {
          SSL_set_fd(ssl, remote);
          SSL_set_connect_state(ssl);
